	;ParachuteOpen
#include "dsoundex.as"
#include "bitpp.as"

#packopt name "paraopen"
#packopt runtime "hsp2c.hrt"
#packopt hide 1

#epack "obj.bmp"

#define MAXRED 5
#define TRANS 255

	screen 0,400,320,2,dispx-400/2,dispy-320/2:title "ParachuteOpen 0.6 by Murachue":onexit *gameexit
	buffer 2:picload "obj.bmp":buffer 3,400,320:color 0,128,128:gmode 4,,,TRANS:buffer 4,400,320:color 0,0,0:boxf:gsel 0,1

	dim dsw,32

	dsw.0=0,0,0,0,0,0,0,0
	;1-1( 0):Always Scr=ToScr
	;1-2( 1):1step Scr+=Bonus
	;1-3( 2):DontShowLevel
	;1-4( 3):DontShowClear
	;1-5( 4):DontShowGameOver
	;1-6( 5):No Bonus
	;1-7( 6):Save DipSwitches
	;1-8( 7):Level Select

	dsw.8=0,1,1,1,1,0,1,0
	;2-1( 8):
	;2-2( 9):Lifes(5) 0,0:3 0,1:5 1,0:6 1,1:7
	;2-3(10):
	;2-4(11):TimeLimit(500) 0,0:200 0,1:300 1,0:400 1,1:500
	;2-5(12):
	;2-6(13):Alarm(100) 0,0:0 0,1:50 1,0:100 1,1:150
	;2-7(14):
	;2-8(15):Interval(50) 0,0:10 0,1:30 1,0:50 1,1:80

	dsw.16=0,1,1,1,0,0,0,0
	;3-1(16):
	;3-2(17):MaxBomb(10) 0,0:7 0,1:10 1,0:20 1,1:50
	;3-3(18):
	;3-4(19):Converging bombing(300) 0,0:50 0,1:100 1,0:200 1,1:300
	;3-5(20):FlipX
	;3-6(21):FlipY
	;3-7(22):Skip ROM check
	;3-8(23):Service mode

	dsw.24=0,0,0,0,0,0,0,0
	;4-1(24):
	;4-2(25):
	;4-3(26):
	;4-4(27):
	;4-5(28):
	;4-6(29):
	;4-7(30):
	;4-8(31):

	lifes=5
	maxbomb=10
	interval=50
	cbomb=300

	gosub *diminit

	gosub *redraw0
	gosub *draw
	pos winx-66/2,150:gcopy 2,0,138,66,14
	gosub *redraw1

	wait 1

	ds_init 22050,2

#define SOUNDS 12
#define SBUF 10
#define S_DROP 0
	ds_load "SE\\DROP.wav"	,S_DROP*SBUF
#define S_INPUT 1
	ds_load "SE\\INPUT.wav"	,S_INPUT*SBUF
#define S_OK 2
	ds_load "SE\\OK.wav"	,S_OK*SBUF
#define S_NG 3
	ds_load "SE\\NG.wav"	,S_NG*SBUF
#define S_ALARM 4
	ds_load "SE\\ALARM.wav"	,S_ALARM*SBUF
#define S_BOMB 5
	ds_load "SE\\BOMB.wav"	,S_BOMB*SBUF
#define S_SELECT 6
	ds_load "SE\\SELECT.wav",S_SELECT*SBUF
#define S_OPEN 7
	ds_load "SE\\OPEN.wav"	,S_OPEN*SBUF
#define S_CLOSE 8
	ds_load "SE\\CLOSE.wav"	,S_CLOSE*SBUF
#define S_MOVE 9
	ds_load "SE\\MOVE.wav"	,S_MOVE*SBUF
#define S_SWITCH 10
	ds_load "SE\\SWITCH.wav",S_SWITCH*SBUF
#define S_CANCEL 11
	ds_load "SE\\CANCEL.wav",S_CANCEL*SBUF

	repeat SOUNDS:c=cnt*SBUF
		repeat 9
			ds_dup c+1+cnt,c
		loop
	loop

	compiled=__DATE__+" "+__TIME__:strlen compl,compiled

	dim chru,26
	;    A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
	chru=5,5,5,5,5,5,5,5,1,5,6,5,5,5,5,5,5,6,5,5,5,5,5,5,5,5
	dim chrl,26
	;    a b c d e f g h i j k l m n o p q r s t u v w x y z
	chrl=4,4,4,4,4,4,4,4,1,4,4,4,5,4,4,4,4,4,4,4,4,5,5,5,5,4

	exist "dipswitc.hes":if strsize!-1{
		sdim buf,4:bload "dipswitc.hes",buf,3
		repeat 24
			bpeek dsw.cnt,buf,cnt/8,cnt\8
		loop
		swon=1:goto *setvals
	}
*reset
	if dsw.22:goto *skipcheck

	gosub *redraw0:color 0,0,0:boxf:color 0,128,128:gosub *redraw1

	wait 50

	;randomize 0
	repeat 20
		gosub *redraw0
		color 0,0,0:boxf:color 0,128,128
		c=cnt
		repeat 400/8*(320/8)
			;rnd x,252/8
			;rnd y,166/8
			x=c*20+cnt\((252/8)*(166/8))\(252/8)
			y=c*20+cnt\((252/8)*(166/8))/(252/8)
			pos cnt\(400/8)*8,cnt/(400/8)*8:gcopy 2,x*8,y*8,8,8
		loop
		gosub *redraw1

		wait 5
	loop

	gosub *redraw0:color 0,0,0:boxf:color 0,128,128:gosub *redraw1

	wait 50

	;randomize 0
	repeat 40
		gosub *redraw0
		color 0,0,0:boxf:color 0,128,128
		c=cnt
		repeat 400/8*(320/8)
			;rnd x,252/8
			;rnd y,166/8
			x=c*20+cnt*5\((252/8)*(166/8))\(252/8)
			y=c*20+cnt*5\((252/8)*(166/8))/(252/8)
			pos cnt\(400/8)*8,cnt/(400/8)*8:gcopy 2,x*8,y*8,8,8
		loop
		gosub *redraw1

		wait 4
	loop

	gosub *redraw0:color 0,0,0:boxf:color 0,128,128:gosub *redraw1

	wait 30

	gosub *redraw0:pos 30,30:st="ROM OK":gosub *prtstr:gosub *redraw1
	wait 30
	gosub *redraw0:pos 30,csry+10:st="RAM OK":gosub *prtstr:gosub *redraw1
	wait 30
*exitservice
	if dsw.22:goto *skipcheck

	if dsw.23=0{
		gosub *redraw0
		color 0,0,0:boxf:color 0,128,128
		repeat (400/16)*(320/16)
			pos cnt\(400/16)*16,cnt/(400/16)*16
			gcopy 2,154,153,16,16
		loop
		gosub *redraw1
		wait 150
	}
*skipcheck
	life=0
	left=0
	clear=0
	scr=0
	;
*gametitle
	wait 1
	gosub *redraw0

	color 0,0,0:boxf:color 0,128,128
	gosub *drawmain

	gosub *redraw1

	gosub *getkys
	if (sky.1)&(sky.3)&(sky.5)&(sky.10)&(sky.11):goto *gamedips
	if ky.12:goto *reset
	if dsw.23{
		if ky.4:sno-:if sno=-1:sno=SOUNDS-1
		if ky.6:sno+:if sno=SOUNDS:sno=0
		if (ky.5)|(ky.10):sn=sno:gosub *sndplay
	}else{
		if ky.10:goto *gameinit
	}

	goto *gametitle

*drawmain
	a=dsw.23:if diping:a=t
	if a{
		sp=30
		pos sp,sp:st="ROM OK":gosub *prtstr
		pos sp,csry+10:st="RAM OK":gosub *prtstr

		pos sp,csry+20:st="SOUND "+sno:gosub *prtstr

		pos sp,csry+20:if dsw.0:st="Scr eq ToScr":gosub *prtstr
		pos sp,csry+10:if dsw.1:st="1Step Bonus":gosub *prtstr
		pos sp,csry+10:if dsw.2:st="Dont Show Level":gosub *prtstr
		pos sp,csry+10:if dsw.3:st="Dont Show Clear":gosub *prtstr
		pos sp,csry+10:if dsw.4:st="Dont Show GameOver":gosub *prtstr
		pos sp,csry+10:if dsw.5:st="No Bonus":gosub *prtstr
		pos sp,csry+10:if dsw.6:st="Save DipSwitches":gosub *prtstr
		pos sp,csry+10:if dsw.7:st="Level Select":gosub *prtstr
		pos sp,csry+10

		if (dsw.8=0)&(dsw.9=0):lifes=3
		if (dsw.8=0)&(dsw.9=1):lifes=5
		if (dsw.8=1)&(dsw.9=0):lifes=6
		if (dsw.8=1)&(dsw.9=1):lifes=7
		pos sp,csry+10:st="Lifes "+lifes:gosub *prtstr
		if (dsw.10=0)&(dsw.11=0):bomcnt=200
		if (dsw.10=0)&(dsw.11=1):bomcnt=300
		if (dsw.10=1)&(dsw.11=0):bomcnt=400
		if (dsw.10=1)&(dsw.11=1):bomcnt=500
		pos sp,csry+10:st="Limit "+bomcnt:gosub *prtstr
		if (dsw.12=0)&(dsw.13=0):warns=0
		if (dsw.12=0)&(dsw.13=1):warns=50
		if (dsw.12=1)&(dsw.13=0):warns=100
		if (dsw.12=1)&(dsw.13=1):warns=150
		pos sp,csry+10:st="Alarm "+warns:gosub *prtstr
		if (dsw.14=0)&(dsw.15=0):interval=10
		if (dsw.14=0)&(dsw.15=1):interval=30
		if (dsw.14=1)&(dsw.15=0):interval=50
		if (dsw.14=1)&(dsw.15=1):interval=80
		pos sp,csry+10:st="Interval "+interval:gosub *prtstr
		if (dsw.16=0)&(dsw.17=0):maxbomb=7
		if (dsw.16=0)&(dsw.17=1):maxbomb=10
		if (dsw.16=1)&(dsw.17=0):maxbomb=20
		if (dsw.16=1)&(dsw.17=1):maxbomb=50
		pos sp,csry+10:st="MaxBombs "+maxbomb:gosub *prtstr
		if (dsw.18=0)&(dsw.19=0):cbomb=50
		if (dsw.18=0)&(dsw.19=1):cbomb=100
		if (dsw.18=1)&(dsw.19=0):cbomb=200
		if (dsw.18=1)&(dsw.19=1):cbomb=300
		pos sp,csry+10:st="Converging Bombing "+cbomb:gosub *prtstr
		pos sp,csry+10

		pos sp,csry+10:if dsw.20:st="X Flip":gosub *prtstr
		pos sp,csry+10:if dsw.21:st="Y Flip":gosub *prtstr
		pos sp,csry+10

		pos sp,csry+10:if dsw.22:st="Skip ROM RAM Check":gosub *prtstr
		pos sp,csry+10:if dsw.23:st="Service Mode":gosub *prtstr
	}else{
		gosub *draw
		pos winx-105/2,150:gcopy 2,0,65,105,19
		pos winx-52/2,200:gcopy 2,74,85,52,7
		pos winx-72/2,308:gcopy 2,0,85,72,7

		pos winx-(compl*6)-54,300-8
		gcopy 2,128,85,52,7
		repeat compl
			pos winx-(compl*6)+(cnt*6),300-8
			a=0:peek a,compiled,cnt
			if a=' ':continue
			if a='/':a='9'+1:else:if a=':':a='9'+2
			a-='0'
			gcopy 2,a*6+181,85,5,7
		loop
	}
	return
*gamedips
	t=dsw.23
	;ssel=0
	sn=S_OPEN:gosub *sndplay
*gamedips_lop
	wait 1
	gosub *redraw0
	color 0,0,0:boxf
	color 0,128,128
	diping=1:gosub *drawmain:diping=0
	gmode 3,,,128:pos 0,0:gcopy 4,0,0,400,320
	gmode 4,,,TRANS

	repeat 4
		pos winx-(74*4)-2/2+(cnt*75),winy-32/2:gcopy 2,0,167,74,32
		c=cnt
		repeat 8
			cc=c*8+cnt
			x=0:if ssel=cc:x=75
			pos winx-(74*4)-2/2+(c*75)+(cnt*9)+1,winy-32/2+1:gcopy 2,cnt*9+x+1,dsw.cc*33+168,9,30
		loop
	loop

	gosub *redraw1

	gosub *getkys
	if ky.4:sn=S_SELECT:gosub *sndplay:ssel-:if ssel=-1:ssel=31
	if ky.6:sn=S_SELECT:gosub *sndplay:ssel+:if ssel=32:ssel=0
	if ky.10:goto *gamedips_close
	if (ky.11)|(ky.5):sn=S_SWITCH:gosub *sndplay:dsw.ssel=dsw.ssel+1\2

	goto *gamedips_lop
*gamedips_close
	sn=S_CLOSE:gosub *sndplay
	sn=tsn
*setvals
	if (dsw.8=0)&(dsw.9=0):lifes=3
	if (dsw.8=0)&(dsw.9=1):lifes=5
	if (dsw.8=1)&(dsw.9=0):lifes=6
	if (dsw.8=1)&(dsw.9=1):lifes=7
	life=0
	if (dsw.14=0)&(dsw.15=0):interval=10
	if (dsw.14=0)&(dsw.15=1):interval=30
	if (dsw.14=1)&(dsw.15=0):interval=50
	if (dsw.14=1)&(dsw.15=1):interval=80
	;
	if (dsw.16=0)&(dsw.17=0):maxbomb=7
	if (dsw.16=0)&(dsw.17=1):maxbomb=10
	if (dsw.16=1)&(dsw.17=0):maxbomb=20
	if (dsw.16=1)&(dsw.17=1):maxbomb=50
	;
	if (dsw.18=0)&(dsw.19=0):cbomb=50
	if (dsw.18=0)&(dsw.19=1):cbomb=100
	if (dsw.18=1)&(dsw.19=0):cbomb=200
	if (dsw.18=1)&(dsw.19=1):cbomb=300
	;
	gosub *diminit

	if swon:swon=0:goto *reset
	if t!dsw.23:if dsw.23:goto *reset:else:goto *exitservice
	goto *gametitle
*gameinit
	scr=0
	toscr=0
	lv=1

	if dsw.7{
		repeat:wait 1
		gosub *redraw0
		gosub *draw
		pos 110,100:st="Select level with key 4 6 2 8":gosub *prtstr
		pos 130,csry+10:st="And start with key 5 or Enter":gosub *prtstr

		pos winx-80/2,150:gcopy 2,46,93,34,14
		pos winx-80/2+50,150:gcopy 2,lv/10*11,108,10,14
		pos winx-80/2+50+12,150:gcopy 2,lv\10*11,108,10,14
		gosub *redraw1

		gosub *getkys
		if ky.4:sn=S_SELECT:gosub *sndplay:lv-:if lv<=0:lv+=99
		if ky.6:sn=S_SELECT:gosub *sndplay:lv+:if lv>=100:lv-=99
		if ky.2:sn=S_SELECT:gosub *sndplay:lv-=10:if lv<=0:lv+=99
		if ky.8:sn=S_SELECT:gosub *sndplay:lv+=10:if lv>=100:lv-=99
		if (ky.5)|(ky.10):sn=S_OK:gosub *sndplay:break
		if ky.12:break
		loop
		if ky.12:goto *reset
	}

	randomize
*gamestage
	gosub *diminit

	lefto=lv-1*2+10
	numl=lv/10+1
	if numl>10:numl=10
	nump=lv\10/3+1
	if (numl+nump)>10:nump=10-numl

	left=lefto
	life=lifes
	last=0
	count=0
	show=0
	clear=0
	inned=0
	red=0
	bonus.0=1
	bonus.1=1
	bonus.4=1

	if dsw.2:goto *gamemain
	repeat 200:wait 1
	gosub *redraw0
	gosub *draw
	if cnt<100{
		pos winx-80/2,150:gcopy 2,46,93,34,14
		pos winx-80/2+50,150:gcopy 2,lv/10*11,108,10,14
		pos winx-80/2+50+12,150:gcopy 2,lv\10*11,108,10,14
	}else{
		pos winx-37/2,150:gcopy 2,0,123,37,14
	}
	gosub *redraw1
	loop
*gamemain
	wait 1

	gosub *redraw0
	gosub *draw
	gosub *redraw1

	gosub *getkys
	if keys:strlen l,innum:if l<10{
		repeat 10:if ky.cnt=1:a=cnt:break
		loop
		innum+=""+a
		sn=S_INPUT:gosub *sndplay
	}
	if (ky.11)&(innum!""):innum="":bonus.1=0:sn=S_CANCEL:gosub *sndplay
	if (ky.10)&(innum!""){
		ok=0
		repeat MAXBOMB
			if bomis.cnt=0:continue
			if bomok.cnt:continue
			if innum=bomnum.cnt:ok=1:bomok.cnt=1:toscr+=bomcnt.cnt:inned+:clear++
		loop
		if ok:sn=S_OK:else:sn=S_NG:bonus.1=0
		gosub *sndplay
		innum=""
	}
	if ky.12:goto *gameover

	if (count>(last+INTERVAL))&(show<lefto){
		rnd a,10
		if a=0{
			repeat MAXBOMB
				if planeis.cnt:continue
				planeis.cnt=1
				planex.cnt=winx
				rnd planedx.cnt,cbomb
				planedx.cnt+=winx-cbomb/2
				rnd planey.cnt,20:planey.cnt+=10
				last=count
				show++
				break
			loop
		}
	}

	count++

	if life=0:goto *gameover
	if inned=lefto:goto *gameclear

	goto *gamemain
*gameclear
	bonus.2=0:if (toscr\10)=0:bonus.2=1
	bonus.3=0:if (toscr\100)=0:bonus.3=1

	bonuses=0
	repeat 5
		bonuses+=bonus.cnt*5000
	loop

	if dsw.3{
		if bonuses:toscr+=bonuses:scr=toscr
		lv++:goto *gamestage
	}
	cn=0
	repeat:wait 1
	gosub *redraw0
	gosub *draw
	if cn<50:pos winx-36/2,150:gcopy 2,41,123,36,14
	if (cn=50)&(bonuses!0)&(dsw.5=0){
		cnn=0:bon=bonuses
		repeat
		gosub *redraw0
		gosub *draw
		pos ,100:if bonus.0:st="NoLine":gosub *lenstr:pos winx-l/2:gosub *prtstr
		pos ,csry+10:if bonus.1:st="NoMiss":gosub *lenstr:pos winx-l/2:gosub *prtstr
		pos ,csry+10:if bonus.2:st="xx0":gosub *lenstr:pos winx-l/2:gosub *prtstr
		pos ,csry+10:if bonus.3:st="x00":gosub *lenstr:pos winx-l/2:gosub *prtstr
		pos ,csry+10:if bonus.4:st="NoBombed":gosub *lenstr:pos winx-l/2:gosub *prtstr

		pos winx-42/2,150:gcopy 2,0,93,42,14
		div=10000
		repeat 5
			n=bon/div\10
			pos winx-54/2+(cnt*11),170:gcopy 2,n*11,108,10,14
			div=div/10
		loop
		if (cnt>100)&(bon>0){
			if dsw.1{
				toscr+=bon
				bon=0
			}else{
				bon-=100
				toscr+=100
			}
			scr=toscr
			sn=S_SELECT:gosub *sndplay
		}
		if bon=0:cnn+:if cnn=50:break
		gosub *redraw1
		loop
	}
	gosub *redraw1
	if cn:cn+:if cn=100:break
	if (cn=0)&(toscr=scr):cn=1
	loop
	lv+:if lv=100:lv=99
	goto *gamestage
*gameover
	if dsw.4:goto *gametitle
	repeat 200:wait 1
	gosub *redraw0
	gosub *draw
	if cnt<100:pos winx-69/2,150:gcopy 2,81,123,69,14
	gosub *redraw1
	loop
	goto *gametitle
*gameexit
	ds_bye

	if dsw.6{
		sdim buf,4
		repeat 24
			bpoke buf,cnt/8,cnt\8,dsw.cnt
		loop
		bsave "dipswitc.hes",buf,3
	}else{
		exist "dipswitc.hes":if strsize!-1:delete "dipswitc.hes"
	}

	end

*draw
	gosub *HidePause

	if red{
		if red=MAXRED:color 255,255,255:else:color 255,0,0
		red-
	}else:color 0,0,0
	boxf

	color 0,128,128:gmode 4,,,TRANS

	repeat MAXBOMB
		if bomis.cnt=0:continue
		if bomok.cnt{
			pos bomx.cnt,bomy.cnt:gcopy 2,0,48,23,15
		}else{
			pos bomx.cnt,bomy.cnt:gcopy 2,24,48,23,15

			if (dsw.12=0)&(dsw.13=0):warns=0
			if (dsw.12=0)&(dsw.13=1):warns=50
			if (dsw.12=1)&(dsw.13=0):warns=100
			if (dsw.12=1)&(dsw.13=1):warns=150

			wrn=0:if warns:if bomcnt.cnt<warns:wrn=1
			warn=wrn*13:warny=wrn*60:warner=wrn*100

			strlen l,bomnum.cnt
			pos bomx.cnt-(l*10/2)+8,bomy.cnt-32:gcopy 2,0+warn,27,4,4
			c=cnt:repeat l*5/2:pos bomx.c-(l*10/2)+(cnt*4)+12,bomy.c-32:gcopy 2,4+warn,27,4,4:loop
				pos bomx.c-(l*10/2)+(l*5/2*4)+12,bomy.c-32:gcopy 2,4+warn,27,l*10/2*2-(l*5/2*4),4
			pos bomx.cnt+(l*10/2)+12,bomy.cnt-32:gcopy 2,8+warn,27,4,4

			c=cnt:repeat 4:pos bomx.c-(l*10/2)+8,bomy.c-28+(cnt*4):gcopy 2,0+warn,31,4,4:loop

			color wrn*255,0,0
			boxf bomx.cnt-(l*10/2)+12,bomy.cnt-28,bomx.cnt+(l*10/2)+12,bomy.cnt-12
			color 0,128,128

			c=cnt:repeat 4:pos bomx.c+(l*10/2)+12,bomy.c-28+(cnt*4):gcopy 2,8+warn,31,4,4:loop

			pos bomx.cnt-(l*10/2)+8,bomy.cnt-12:gcopy 2,0+warn,35,4,4
			c=cnt:repeat l*5/2:pos bomx.c-(l*10/2)+(cnt*4)+12,bomy.c-12:gcopy 2,4+warn,35,4,4:loop
				pos bomx.c-(l*10/2)+(l*5/2*4)+12,bomy.c-12:gcopy 2,4+warn,35,l*10/2*2-(l*5/2*4),4
			pos bomx.cnt+(l*10/2)+12,bomy.cnt-12:gcopy 2,8+warn,35,4,4

			pos bomx.cnt+(24-8/2),bomy.cnt-9:gcopy 2,0+warn,39,8,8

			c=cnt:repeat l
			a=0:peek a,bomnum.c,cnt:a-='0'
			pos bomx.c-(l*10/2)+(cnt*10)+12,bomy.c-28:gcopy 2,a*10+warner,0,9,16
			loop

			c=cnt
			div=100
			repeat 3
				n=bomcnt.c/div\10
				pos cnt*6+bomx.c+24,bomy.c-8:gcopy 2,n*6+warny,17,5,9
				div=div/10
			loop

			if bomcnt.cnt=0:bonus.4=0:bomis.cnt=0:life-:inned+:red=MAXRED:sn=S_BOMB:gosub *sndplay

			if warns:if bomcnt.cnt=warns:if life>0:sn=S_ALARM:gosub *sndplay
			bomcnt.cnt-
		}
		if bomy.cnt<300:bomy.cnt+:else:if bomok.cnt:bomis.cnt=0:else:bonus.0=0
	loop
	repeat MAXBOMB
		if planeis.cnt=0:continue
		pos planex.cnt,planey.cnt:gcopy 2,50,27,77,13
		if planex.cnt=planedx.cnt{
			c=cnt
			a=0:repeat MAXBOMB:if bomis.cnt=0:a=cnt:break
			loop
			bomis.a=1
			bomy.a=planey.c+20
			bomx.a=planex.c+20
			bomok.a=0
			bomnum.a=""
			rnd p,nump+1
			repeat numl+p
				rnd n,10
				bomnum.a+=""+n
			loop
			if (dsw.10=0)&(dsw.11=0):bomcnt.a=200
			if (dsw.10=0)&(dsw.11=1):bomcnt.a=300
			if (dsw.10=1)&(dsw.11=0):bomcnt.a=400
			if (dsw.10=1)&(dsw.11=1):bomcnt.a=500
			left-
			sn=S_DROP:gosub *sndplay
		}
		planex.cnt-:if planex.cnt=-77:planeis.cnt=0
	loop

	pos 0,0:gcopy 2,120,17,29,9
	div=1000000
	repeat 7
		n=scr/div\10
		pos cnt*6+29+6,0:gcopy 2,n*6,17,5,9
		div=div/10
	loop
	pos 100,0:gcopy 2,150,17,17,9
		pos 117+6,0:gcopy 2,lv/10*6,17,5,9
		pos 6+117+6,0:gcopy 2,lv\10*6,17,5,9
	pos 170,0:gcopy 2,168,17,23,9
		pos 193+6,0:gcopy 2,left/10*6,17,5,9
		pos 6+193+6,0:gcopy 2,left\10*6,17,5,9
		;pos 12+193+6,0:gcopy 2,132,17,5,9
		;pos 18+193+6,0:gcopy 2,left/10*6,17,5,9
		;pos 24+193+6,0:gcopy 2,left\10*6,17,5,9
	pos 250,0:gcopy 2,198,17,29,9
		pos 279+6,0:gcopy 2,clear/10*6,17,5,9
		pos 6+279+6,0:gcopy 2,clear\10*6,17,5,9

	repeat LIFES
		pos winx-(LIFES*12)+(cnt*12),0:gcopy 2,26,27,11,11
	loop
	repeat LIFES-life
		pos winx-(LIFES*12)+(cnt*12),0:gcopy 2,38,27,11,11
	loop

	color 255,255,255
	pos 0,302:line 400,302
	color 0,0,0
	boxf 0,303,400,320
	color 0,128,128
	strlen l,innum
	repeat l
		a=0:peek a,innum,cnt:a-='0'
		pos cnt*10,304:gcopy 2,a*10,0,10,16
	loop

	if scr<toscr:if dsw.0:scr=toscr:else:scr+=6:if scr>toscr:scr=toscr

	return
*getkys
	gosub *hidepause

	keys=0
	repeat 10:getkey mky.cnt,48+cnt:loop
	repeat 10:getkey tky.cnt,96+cnt:loop
	repeat 10:if mky.cnt|tky.cnt:ky.cnt=1:keys+:else:ky.cnt=0
	loop

	getkey ky.10,13
	getkey ky.11,32
	getkey ky.12,27

	repeat 13:sky.cnt=ky.cnt:if ky.cnt=0:pky.cnt=0:else:if pky.cnt:ky.cnt=0:keys-:else:pky.cnt=1
	loop

	if keys<0:keys=0

	return
*diminit
	dim bomis,MAXBOMB
	dim bomx,MAXBOMB
	dim bomy,MAXBOMB
	dim bomok,MAXBOMB
	sdim bomnum,11,MAXBOMB
	dim bomcnt,MAXBOMB

	dim planeis,MAXBOMB
	dim planex,MAXBOMB
	dim planedx,MAXBOMB
	dim planey,MAXBOMB

	sdim innum,11

	repeat SOUNDS:sndptr.cnt=cnt*SBUF:loop

	return
*sndplay
	ds_play sndptr.sn
	sndptr.sn+
	if sndptr.sn=(sn+1*SBUF):sndptr.sn=sn*10
	return
*lenstr
	strlen le,st:l=0
	repeat le
		a=0:peek a,st,cnt
		if ('A'<=a)&(a<='Z'):b=a-'A':lx=chru.b:a=0
		if ('a'<=a)&(a<='z'):b=a-'a':lx=chrl.b:a=0
		if ('0'<=a)&(a<='9'):b=a-'0':lx=5:a=0
		if a=' ':lx=0:a=0
		if a!0:continue
		if lx=0:l+=6:continue
		l+=lx
	loop
	return
*prtstr
	x=csrx:y=csry
	strlen l,st

	repeat l
		a=0:peek a,st,cnt
		if ('A'<=a)&(a<='Z'):b=a-'A':sx=0:repeat b:sx+=chru.cnt+1:loop:sy=153:lx=chru.b:ly=7:yp=0:a=0
		if ('a'<=a)&(a<='z'):b=a-'a':sx=0:repeat b:sx+=chrl.cnt+1:loop:sy=161:lx=chrl.b:ly=5:yp=2:a=0
		if ('0'<=a)&(a<='9'):b=a-'0':sx=b*6+181:sy=85:lx=5:ly=7:yp=0:a=0
		if a=' ':lx=0:a=0
		if a!0:continue
		if lx=0:x+=6:continue
		pos x,y+yp:gcopy 2,sx,sy,lx,ly
		x+=lx+1
	loop

	pos x,y

	return
*HidePause
	ginfo 1:if prmx!0{
		repeat:wait 10
		ginfo 1:if prmx=0:break
		loop
	}
	return
*redraw0
	redraw 0
	if (dsw.20)|(dsw.21):gsel 3
	return
*redraw1
	if (dsw.20)|(dsw.21){
		gsel 0
		if (dsw.20=1)&(dsw.21=0):pos 399,  0:gzoom -400,320,3,0,0,400,320
		if (dsw.20=0)&(dsw.21=1):pos   0,319:gzoom 400,-320,3,0,0,400,320
		if (dsw.20=1)&(dsw.21=1):pos 399,319:gzoom -400,-320,3,0,0,400,320
	}
	redraw 1
	return
